import { Disposable } from '@vscode/monaco-editor/esm/vs/base/common/lifecycle';
import { ResolvedKeybindingItem } from '@vscode/monaco-editor/esm/vs/platform/keybinding/common/resolvedKeybindingItem';
import { ApolloClient } from 'apollo-client';
import { InMemoryCache } from 'apollo-cache-inmemory';
import { IClientConfigurationService, IEnvironmentService, IKeybindingEditingService, ILifecycleService } from '@workbench-stack/core';
import { IClientFileService as IFileService, ITextFileService } from '@files-stack/core';
export declare class KeybindingsEditingService extends Disposable implements IKeybindingEditingService {
    client: ApolloClient<any>;
    cache: InMemoryCache;
    private lifecycleService;
    private textFileService;
    private fileService;
    private configurationService;
    private environmentService;
    _serviceBrand: undefined;
    private queue;
    private resource;
    constructor(client: ApolloClient<any>, cache: InMemoryCache, lifecycleService: ILifecycleService, textFileService: ITextFileService, fileService: IFileService, configurationService: IClientConfigurationService, environmentService: IEnvironmentService);
    private postSetup;
    editKeybinding(keybindingItem: ResolvedKeybindingItem & {
        id: string;
    }, key: string, when: string | undefined): Promise<void>;
    resetKeybinding(keybindingItem: ResolvedKeybindingItem): Promise<void>;
    removeKeybinding(keybindingItem: ResolvedKeybindingItem): Promise<void>;
    private doEditKeybinding;
    private doRemoveKeybinding;
    private doResetKeybinding;
    private save;
    private updateKeybinding;
    private removeUserKeybinding;
    private removeDefaultKeybinding;
    private removeUnassignedDefaultKeybinding;
    private findUserKeybindingEntryIndex;
    private findUnassignedDefaultKeybindingEntryIndex;
    private asObject;
    private applyEditsToBuffer;
    private resolveModelReference;
    private resolveAndValidate;
    private parse;
    private getEmptyContent;
}
